package com.sqx.modules.pay.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sqx.modules.datacentre.query.DataCenterQuery;
import com.sqx.modules.pay.controller.query.CashOutQueryDTO;
import com.sqx.modules.pay.entity.CashOut;
import com.sqx.modules.pay.vo.CashOutVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Date;
import java.util.List;

/**
 * @author fang
 * @date 2020/7/8
 */
@Mapper
public interface CashOutDao extends BaseMapper<CashOut> {

    List<CashOut> selectCashOutLimit3();

    Double selectCashOutSum(@Param("userId") Long userId, @Param("startTime") Date startTime, @Param("endTime") Date endTime);

    Double selectCashOutSumsByNowMonth(@Param("userId") Long userId);

    void updateMayMoney(@Param("type") Integer type,@Param("userId")Long userId,@Param("money") Double money);

    Double selectMayMoney(@Param("userId") Long userId);

    BigDecimal sumMoney(@Param("date") String date, @Param("dateType") String dateType, @Param("state") Integer state ,@Param("type") Integer type);

    Integer countMoney(@Param("date") String date, @Param("dateType") String dateType, @Param("state") Integer state, @Param("type") Integer type);

    Integer stayMoney(@Param("date") String date, @Param("dateType") String dateType, @Param("type") Integer type);

    BigDecimal applyMoneySum(@Param("date") String date, @Param("dateType") String dateType, @Param("type") Integer type);

    BigDecimal accomplishMoneySum(@Param("date") String date, @Param("dateType") String dateType, @Param("type") Integer type);

    BigDecimal refuseMoneySum(@Param("date") String date, @Param("dateType") String dateType, @Param("type") Integer type);

    BigDecimal zhifubaoMoneySum(@Param("date") String date, @Param("dateType") String dateType, @Param("type") Integer type);

    BigDecimal weixinMoneySum(@Param("date") String date, @Param("dateType") String dateType, @Param("type") Integer type);

    BigDecimal cashDepositMoneySum(@Param("date") String date, @Param("dateType") String dateType);

    BigDecimal cargoInsurance(@Param("query") DataCenterQuery query);

    BigDecimal MoneySumByIndentType(@Param("query") DataCenterQuery query, String indentType);

    BigDecimal cashDepositMoney(@Param("query") DataCenterQuery query);

    IPage<CashOutVO> selectCashOutList(@Param("page") IPage<CashOut> pages, @Param("params") CashOutQueryDTO queryDTO);

    IPage<CashOutVO> selectRiderCashOutList(@Param("pages") Page<CashOut> pages, @Param("params") CashOutQueryDTO queryDTO);

    Double selectCashOutTotal(@Param("params") CashOutQueryDTO queryDTO);

    Double selectCommissionTotal(@Param("params") CashOutQueryDTO queryDTO);

    List<CashOutVO> excelPayDetails(@Param("params") CashOutQueryDTO queryDTO);
}
